{------------------------------------------------------------------------------}
{
   Unit Name: rusinaauto
   Purpose  : Rusinaksi trmyksess muuttuva auto
   Author   : Vesa Lappalainen
   Date     : 14.11.1999
   Changed  :

   ToDo     :
}
{------------------------------------------------------------------------------}

unit rusinaauto;

interface
uses classes,graphics,sprite,auto;

type
  TRusinaState = ( rs_OK, rs_Palaa, rs_Rusina );

  TRusinaksiMuuttuvaAuto = class(TAuto)
  private
    FCounter : integer;
    FPaloAika: integer;
    FRusinaState: TRusinaState;
  public
    constructor Create(AOwner:TComponent); override;
    function PaintTo(canvas:TCanvas):boolean; override;
    function AutoReact(sprite:TSprite):boolean; override;
    function DoJob:boolean; override;
    procedure Syty;
  published
    property PaloAika : integer read FPaloAika write FPaloAika;
    property FState : TRusinaState read FRusinaState;
  end;

implementation

{ TRusinaksiMuuttuvaAuto }

function TRusinaksiMuuttuvaAuto.DoJob: boolean;
begin
  if FRusinaState = rs_OK then begin
    result := inherited DoJob;
    exit;
  end;
  Result := false;
  inc(FCounter);
  if (FCounter < Paloaika) then exit;
  Result := true;
  if ( FRusinaState = rs_Palaa ) then begin
    FCounter := 0;
    FRusinaState := rs_Rusina;
    exit;
  end;
  Parent.UnJoin(self,true);  
end;

function TRusinaksiMuuttuvaAuto.PaintTo(canvas: TCanvas): boolean;
var rx,ry : integer;
begin
  if FRusinaState < rs_Rusina then inherited PaintTo(canvas);
  if FRusinaState = rs_Palaa then begin
    rx := iw * FCounter div paloaika div 2;
    ry := ih * FCounter div paloaika div 2;
    canvas.Brush.Color := clYellow;
    canvas.Ellipse(ix+iw div 2 - rx,iy,ix + iw div 2 + rx, iy + 2*ry);
  end;
  if FRusinaState = rs_Rusina then begin
    rx := iw div 2 - iw * FCounter div paloaika div 2;
    ry := ih div 2 - ih * FCounter div paloaika div 2;
    canvas.Brush.Color := clMaroon;
    canvas.Ellipse(ix+iw div 2 - rx,iy,ix + iw div 2 + rx, iy + 2*ry);
  end;
  Result := true;
end;

function TRusinaksiMuuttuvaAuto.AutoReact(sprite: TSprite): boolean;
begin
  if ( sprite is TAuto ) then begin
    Syty;
    if ( sprite is TRusinaksiMuuttuvaAuto ) then
      TRusinaksiMuuttuvaAuto(sprite).Syty
    else
      parent.UnJoin(sprite,true);
  end;
  Result := true;
end;

procedure TRusinaksiMuuttuvaAuto.Syty;
begin
  if  not ( FRusinaState = rs_OK ) then exit;  // jos palaa jo, ei syty en
  FRusinaState := rs_Palaa;
end;

constructor TRusinaksiMuuttuvaAuto.Create(AOwner: TComponent);
begin
  inherited;
  PaloAika := 20;
end;

end.
