unit test;
(*
  Esimerkki
    1) Liikkuvan auton kytst
    2) Olion dynaamisesta luomisesta
    3) Olion lhettmn omatekoisen viestin vastaanottamisesta

  Tarvitsee toimiakseen
    test.pas         - tm tiedosto
    auto.pas         - TSpritest peritty auto
    sprite.pas       - kantalauokka koko liikuttelulle
    traffic.pas      - liikennevalot
    rusinaauto.pas   - auto joka syttyy palamaan ja kutistuu rusinaksi
    driversbrain.pas - autoon ly, joka osaa reagoida liikennevaloihin

  Vesa Lappalainen 14.11.1999
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,Auto, StdCtrls, sprite, traffic, DriversBrain, rusinaauto;

type
  TFormAutoTesti = class(TForm)
    PanelOptions: TPanel;
    EditAutoja: TEdit;
    LabelAutoja: TLabel;
    LabelKA: TLabel;
    EditKA: TEdit;
    LabelLV: TLabel;
    EditLV: TEdit;
    ButtonUusi: TButton;
    procedure FormCreate(Sender: TObject);
    procedure AutoMove(sender:TAuto);
    procedure KAutoChangeDir(sender: TObject; dir: Integer);
    procedure EditAutojaEnter(Sender: TObject);
    procedure ButtonUusiClick(Sender: TObject);
  private
    Auto : TAuto;
    space : TSpriteSpace;
  public
    procedure Uusi;
  end;

var
  FormAutoTesti: TFormAutoTesti;

implementation

{$R *.DFM}

procedure TFormAutoTesti.FormCreate(Sender: TObject);
begin
  Randomize();
  uusi;
end;

procedure TFormAutoTesti.AutoMove(sender:TAuto);
begin
//
end;

procedure TFormAutoTesti.KAutoChangeDir(sender: TObject; dir: Integer);
begin
//
end;

procedure TFormAutoTesti.EditAutojaEnter(Sender: TObject);
begin
  if not ( sender is TEdit ) then exit;
  TEdit(Sender).SelectAll;
end;

function Num(e:TEdit;m:integer=40):integer;
begin
  Result := StrToIntDef(e.text,1);
  if ( Result > m ) then Result := m;
end;

procedure TFormAutoTesti.Uusi;
var i:integer;  tl : TTrafficLights; n:integer;
begin
  Randomize();
  space := TSpriteSpace.Create(self);
  space.Parent := self;
  space.Align := alClient;
  n := Num(EditAutoja,80)+Num(EditKa,50);
  for i:=0 to n-1 do begin
    Auto := TRusinaksiMuuttuvaAuto.Create(space);
    TDriversBrain.Create(Auto);
    Auto.x := Random(Space.ClientWidth-50);
    Auto.y := Random(Space.ClientHeight-20);
  //  Auto.Parent := self;
    if ( Random(n) > Num(EditKA) ) then
      Auto.BitName := 'Hauto.bmp'
    else
      Auto.BitName := 'kauto.bmp';
    Auto.Vauhti := Random(20)+1;
//    Auto.OnAutoMove := AutoMove;
//    Auto.OnChangeDir := KAutoChangeDir;
  end;

  for i:=0 to Num(EditLV,40)-1 do begin
    tl := TTrafficLights.Create(space);
    tl.x := Random(Space.ClientWidth-50);
    tl.y := Random(Space.ClientHeight-20);
    tl.Interval := 40 + Random(100);
  end;

  Space.Interval := 100;
  Space.Running := true;
end;

procedure TFormAutoTesti.ButtonUusiClick(Sender: TObject);
begin
  Space.Running := false;
  Space.Free;
  Uusi;
end;

end.
